#include <iostream>
#include <string>
#include "PA.h"

using namespace std;

int main(int argc, char** argv) {

// Shortest Path Example with 7 nodes
/*
	PS ps;
	cout << "Example 1 Path Algebra: " << ps << endl;
	auto mex1 = MatrixAlgebra(ps, 7);
	mex1.FromFile("ShortestPath_Example1_7x7.txt");
	auto cwmex1 = ClosureWeak  (mex1);
	cout << "Weak closure: " << endl << cwmex1 << endl;
	cwmex1.ToFile("ShortestPath_Example1_7x7_Result.txt");
*/

// Most Reliable Path Example with 7 nodes
/*
	PR pr;	
	cout << "Example 1 Path Algebra: " << pr << endl;
	auto mex1 = MatrixAlgebra(pr, 7);
	mex1.FromFile("MostReliablePath_Example1_7x7.txt");
	auto cwmex1 = ClosureWeak  (mex1);
	cout << "Weak closure: " << endl << cwmex1 << endl;
	cwmex1.ToFile("MostReliablePath_Example1_7x7_Result.txt");
*/

// Max Path Capacity Example with 7 nodes
/*
	PC pc;
	cout << "Example 1 Path Algebra: " << pc << endl;
	auto mex1 = MatrixAlgebra(pc, 7);
	mex1.FromFile("MaxPathCapacity_Example1_7x7.txt");
	auto cwmex1 = ClosureWeak  (mex1);
	cout << "Weak closure: " << endl << cwmex1 << endl;
	cwmex1.ToFile("MaxPathCapacity_Example1_7x7_Result.txt");
*/

// Composite Shortest Path Example with 7 nodes
/*
	PS ps;
	PE pe;
	auto cpspe = CompositeAlgebra(ps,pe);
	cout << "Example 1 Path Algebra: " << cpspe << endl;
	auto mex1 = MatrixAlgebra(cpspe, 7);
	mex1.FromFile("CompositeShortestPath_Example1_7x7.txt");
	auto cwmex1 = ClosureWeak  (mex1);
	cout << "Weak closure: " << endl << cwmex1 << endl;
	cwmex1.ToFile("CompositeShortestPath_Example1_7x7_Result.txt");
*/

// Multiobjective (3-objectives) Example with 7 nodes
/*
	PS ps; 
	PR pr; 
	PC pc;
	auto ex1 = S(V(ps,pr,pc));
	auto mex1 = MatrixAlgebra(ex1, 7);
	mex1.FromFile("MultiObjective_Example1_7x7.txt");
	auto cwmex1 = ClosureWeak  (mex1);
	cout << "Weak closure: " << endl << cwmex1 << endl;
	cwmex1.ToFile("MultiObjective_Example1_7x7_Result.txt");
*/

// Robust Shortest Path Example with 7 nodes
/*
	PS ps; 
	PE pe; 
	auto ex2 = C(V<4>(ps),pe);
	auto mex2 = MatrixAlgebra(ex2, 7);
	mex2.FromFile("RobustShortestPath_Example1_7x7.txt");
	auto cwmex2 = ClosureWeak  (mex2);
	cout << "Weak closure: " << endl << cwmex2 << endl;
	cwmex2.ToFile("RobustShortestPath_Example1_7x7_Result.txt");
	cout << "MaxMinValue   = " << MaxMinValue(cwmex2[0][6]) << endl;
	cout << "MaxMinAlgebra = " << MaxMinAlgebra(cwmex2[0][6]) << endl;
*/

// Robust Most Reliable Path Example with 7 nodes
/*
	PR pr; 
	PE pe; 
	PA pa;	
	auto ex3 = C(V<4>(pr),pa);
	auto mex3 = MatrixAlgebra(ex3, 7);
	mex3.FromFile("RobustMostReliablePath_Example1_7x7.txt");
	auto cwmex3 = ClosureWeak  (mex2);
	cwmex3.ToFile("RobustMostReliablePath_Example1_7x7_Result.txt");
	cout << "Weak closure: " << endl << cwmex3 << endl;
	cout << "MaxMinValue   = " << MaxMinValue(cwmex3[0][6]) << endl;
	cout << "MaxMinAlgebra = " << MaxMinAlgebra(cwmex3[0][6]) << endl;
	cout << "AvgVectorNumber = " << AvgVectorNumber(cwmex3) << endl;
*/
	return 0;
}

